#!/bin/bash
SNAPUSER=put_username_here

if [ "$1" == "config" ] ; then
	echo graph_title Snap Internet Quota
	echo graph_args --base 1024 -l 0
	echo graph_category custom
	echo graph_vlabel Usage
	echo used.label Usage
	echo used.cdef used,1024,*,1024,*
	echo used.draw AREA
	echo quota.label Quota
	echo quota.cdef quota,1024,*,1024,*
	echo quota.colour ff0000
	
	exit 0
fi

SNAPINFO=`wget -q --no-check-certificate --post-data "u=${SNAPUSER}%40snap.net.nz" "https://www.snap.net.nz/usage.php" -O - -4`

if [ $? -ne 0 ] ; then
	echo Error retrieving Snap data >&2
	exit 1
fi

USAGE=`echo "${SNAPINFO}" | sed -E "s/.*Used:([0-9]+).*/\1/"`
QUOTA=`echo "${SNAPINFO}" | sed -E "s/.*Quota:([0-9]+).*/\1/"`

echo used.value $USAGE
echo quota.value $QUOTA
exit 0
