#!/usr/bin/php5
<?php

define('SNAP_USERNAME',  ''); // put username here
define('SNAP_PASSWORD',  ''); // put password here

if (count($_SERVER['argv']) > 1 && $_SERVER['argv'][1] == 'config') {
    echo <<<EOC
graph_title Snap Internet Quota
graph_args --base 1000 -l 0
graph_scale no
graph_category custom
graph_vlabel Data Usage (GB)
down.label Regular Download
down.colour f26522
down.draw AREA
up.label Regular Upload
up.colour 00007f
up.draw STACK
youtube.label Free Youtube
youtube.colour 007f00
youtube.draw STACK
offpeak.label Uncapped Nights
offpeak.colour fff000
offpeak.draw STACK
cap.label Data Cap
cap.colour ff0000
cap.draw LINE
usage.label Recorded Usage
usage.colour 000000
usage.draw LINE

EOC;
    die();
}

function http($url, $data=array()) {
    static $ch = null;
    if (is_null($ch)) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        if (stripos(PHP_OS, 'win') !== false) {
            curl_setopt($ch, CURLOPT_COOKIEJAR, 'NUL');
        } else {
            curl_setopt($ch, CURLOPT_COOKIEJAR, '/dev/null');
        }
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);    
        curl_setopt($ch, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4);        
        //curl_setopt($ch, CURLOPT_VERBOSE, true);
    }
    
    curl_setopt($ch, CURLOPT_URL, $url);
    
    if (count($data)) {
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
    } else {
        curl_setopt($ch, CURLOPT_POSTFIELDS, null);
        curl_setopt($ch, CURLOPT_POST, false);
        curl_setopt($ch, CURLOPT_HTTPGET, true);
    }
    
    $ret = curl_exec($ch);
    if ($ret === false) {
        trigger_error(curl_error($ch));
    }
    return $ret;
}

// Get cap

$apidata = explode('|', http("https://www.snap.net.nz/usage.php", array(
    'u' => SNAP_USERNAME
)));

// Log in to main site

http('https://myaccount.snap.net.nz/login', array(
    'form_Username' => SNAP_USERNAME,
    'form_Password' => SNAP_PASSWORD,
    'action' => 'Login'
));

$usage = http('https://myaccount.snap.net.nz/summary/dynamic/daily/?date='.urlencode(date('Y-m-d H:i:s')));

$matches = array();
preg_match_all(
    '/<td style=\\\' padding:10px; width:[^>]+>([^<]*):<br><b>([0-9\.]+)/',
    $usage,
    $matches,
    PREG_SET_ORDER
);

// Format results for munin

$display = array(
    'down' => 0,
    'up' => 0,
    'youtube' => 0,
    'offpeak' => 0,
    'cap' => 0,
    'usage' => 0
);

foreach($matches as $match) {
    switch($match[1]) {
        case 'Regular Download': $display['down']    = $match[2]; break;
        case 'Regular Upload':   $display['up']      = $match[2]; break;
        case 'Free Youtube':     $display['youtube'] = $match[2]; break;
        case 'Uncapped Nights':  $display['offpeak'] = $match[2]; break;
    }
}

if (count($apidata) == 9) { // check expected format
    $display['usage'] = intval(substr($apidata[2], strlen('Used:'))) / 1024;
    $display['cap']   = intval(substr($apidata[3], strlen('Quota:'))) / 1024;    
}

foreach($display as $dk => $dv) {
    echo $dk.'.value '.number_format($dv, 2, '.', '')."\n";
}
